unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, Math;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    txbMapa: TEdit;
    btnMapa: TButton;
    dgMapa: TDrawGrid;
    Label2: TLabel;
    btnCesta: TButton;
    mCesta: TMemo;
    Button1: TButton;
    OpenDialog: TOpenDialog;
    Label4: TLabel;
    cbPolicko: TComboBox;
    procedure btnMapaClick(Sender: TObject);
    procedure dgMapaDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure dgMapaSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure btnCestaClick(Sender: TObject);
    procedure cbPolickoChange(Sender: TObject);
  private
    procedure ChangeSize(Rows, Cols: integer);
  public
    { Public declarations }
  end;

  type TCesta = class(TList)
    Narazil: boolean;

  end;

  type TZmena = record
    X: smallint;
    Y: smallint;
  end;

  type TBod = class
      Souradnice: TPoint;
      Rychlost: TPoint;
      Zmena: TZmena;
      Narazil: boolean;
      Used: integer;
  end;

var
  Form1: TForm1;
  Mapa: array of array of array of integer;

  Start: TBod;
  Cil: array of TPoint;

  DelkaRadku: integer;

  procedure Error(S: string);

implementation

{$R *.dfm}

procedure Error(S: string);
begin
  MessageDlg(S, mtError, [mbOK], 0);
end;

procedure TForm1.btnMapaClick(Sender: TObject);
var
  MapFile: TextFile;
  Radek: String;
  Ctverecek: integer;
  I: integer;
begin
  SetLength(Mapa, 0, 0, 0);
  SetLength(Cil, 0);
  Start := TBod.Create;
  Start.Souradnice.X := -1;
  DelkaRadku := 0;
  if OpenDialog.Execute then
  begin
    txbMapa.Text := OpenDialog.FileName;
    AssignFile(MapFile, OpenDialog.FileName);
    try
      Reset(MapFile);
      while not EOF(MapFile) do
      begin
        Readln(MapFile, Radek);
        if DelkaRadku < Length(Radek) then
          DelkaRadku := Length(Radek);
        SetLength(Mapa, Length(Mapa)+1, DelkaRadku, 2);
        for I := 1 to DelkaRadku do
        begin
          case radek[I] of
            'X': Ctverecek := 0;
            'S':
              begin
                Ctverecek := 1;
                Start.Souradnice.X := I-1;
                Start.Souradnice.Y := High(Mapa);
                Start.Rychlost.X := 0;
                Start.Rychlost.Y := 0;
                Start.Zmena.X := 0;
                Start.Zmena.Y := 0;
                Start.Narazil := False;
              end;
            'C':
              begin
                Ctverecek := 2;
                SetLength(Cil, Length(Cil)+1);
                Cil[High(Cil)].X := I-1;
                Cil[High(Cil)].Y := High(Mapa);
              end;
            '.': Ctverecek := 3;
            ':': Ctverecek := 4;
            else
            begin
              Error('patn formt mapy !');
              Exit;
            end;
          end;
          Mapa[High(Mapa), I-1, 0] := Ctverecek;
          Mapa[High(Mapa), I-1, 1] := -1;
        end;
      end;
      ChangeSize(Length(Mapa), DelkaRadku);
    finally
      CloseFile(MapFile);
    end;
    if (Start.Souradnice.X = -1) or (Length(Cil) = 0) then
    begin
      Error('Mapa neobsahuje bu start nebo cl.');
      SetLength(Mapa, 0, 0, 0);
    end;
  end;
  dgMapa.Repaint;
end;

procedure TForm1.dgMapaDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if Length(Mapa) > 0 then
  begin
    case Mapa[ARow, ACol, 0] of
      0: dgMapa.Canvas.Brush.Color := clRed;
      1: dgMapa.Canvas.Brush.Color := clYellow;
      2: dgMapa.Canvas.Brush.Color := clGreen;
      3: dgMapa.Canvas.Brush.Color := clGray;
      4: dgMapa.Canvas.Brush.Color := clBlack;
    end;
    dgMapa.Canvas.FillRect(Rect);
  end;
end;

procedure TForm1.ChangeSize(Rows, Cols: integer);
begin
  dgMapa.RowCount := Rows;
  dgMapa.ColCount := Cols;
end;

procedure TForm1.dgMapaSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  CanSelect := False;
end;

procedure TForm1.btnCestaClick(Sender: TObject);
var
  Dalsi: TList;
  Pozice: TList;
  I, J: integer;
  ModX, ModY: integer;
  Cesta: TCesta;
  StaraCesta: TCesta;
  StaryBod, Bod: TBod;
  Vysledek: TCesta;
  Konec: boolean;
  S: string;
  Zmena: TZmena;
begin
  if Length(Mapa) > 0 then
  begin
    mCesta.Clear;
    Vysledek := nil;
    Konec := False;
    Pozice := TList.Create;
    Dalsi := TList.Create;
    Cesta := TCesta.Create;
    Cesta.Add(Start);
    Pozice.Add(Cesta);
    repeat
      for I := 0 to Pozice.Count -1 do
      begin
        StaraCesta := TCesta(Pozice[I]);
        StaryBod := TBod(StaraCesta[StaraCesta.Count-1]);
        for ModX := -1 to 1 do
        begin
          if StaraCesta.Narazil and (StaryBod.Rychlost.X + ModX > 5) then
            Continue;
          for ModY := -1 to 1 do
          begin
            if ModX+ModY+StaryBod.Rychlost.X+StaryBod.Rychlost.Y = 0 then
              Continue;
            if StaraCesta.Narazil and (StaryBod.Rychlost.Y + ModY > 5) then
              Continue;
            if (StaryBod.Zmena.X = (-1)*ModX) and (StaryBod.Zmena.Y = (-1)*ModY) then
              Continue;
            if StaraCesta.Count > 4 then
            begin
              for J := StaraCesta.Count-1 downto StaraCesta.Count-5 do
              begin
                Zmena.X := Zmena.X + TBod(StaraCesta[J]).Zmena.X;
                Zmena.Y := Zmena.Y + TBod(StaraCesta[J]).Zmena.Y;
              end;
              if Abs(Zmena.X) + Abs(Zmena.Y) < 3 then
                Continue;
            end;


            Cesta := TCesta.Create;
            Cesta.Assign(StaraCesta);
            Cesta.Narazil := StaraCesta.Narazil;
            Bod := TBod.Create;

            Bod.Zmena.X := ModX;
            Bod.Zmena.Y := ModY;
            Bod.Rychlost.X := StaryBod.Rychlost.X + ModX;
            Bod.Rychlost.Y := StaryBod.Rychlost.Y + ModY;
            Bod.Souradnice.X := StaryBod.Souradnice.X + Bod.Rychlost.X;
            Bod.Souradnice.Y := StaryBod.Souradnice.Y + Bod.Rychlost.Y;

            if (Bod.Souradnice.X > DelkaRadku) or (Bod.Souradnice.Y > High(Mapa)) or
               (Bod.Souradnice.X < 0) or (Bod.Souradnice.Y < 0) or
               (Mapa[Bod.Souradnice.Y, Bod.Souradnice.X, 0] = 0) then
            begin
              if (StaryBod.Rychlost.Y = 0) and (StaryBod.Rychlost.X = 0) then
              begin
                Cesta.Free;
                Bod.Free;
                Continue;
              end;
              Bod.Narazil := True;
              Cesta.Narazil := True;
              Bod.Souradnice.X := StaryBod.Souradnice.X;
              Bod.Souradnice.Y := StaryBod.Souradnice.Y;
              Bod.Rychlost.X := 0;
              Bod.Rychlost.Y := 0;
            end else
            begin
              if (Mapa[Bod.Souradnice.Y, Bod.Souradnice.X, 1]+4 < Cesta.Count)and (Mapa[Bod.Souradnice.Y, Bod.Souradnice.X, 1]>-1)  then
              begin
                Cesta.Free;
                Bod.Free;
                Continue;
              end;
            end;

            Mapa[Bod.Souradnice.Y, Bod.Souradnice.X, 1] := Min(Mapa[Bod.Souradnice.Y, Bod.Souradnice.X, 1], Cesta.Count);

            Cesta.Add(Bod);
            Dalsi.Add(Cesta);
          end;
        end;
        StaraCesta.Free;
      end;
      Pozice.Assign(Dalsi);
      Dalsi.Clear;
      if Pozice.Count = 0 then
        Konec := True;
      for I := 0 to Pozice.Count -1 do
      begin
        Cesta := Pozice[I];
        Bod := Cesta[Cesta.Count-1];
        for J := 0 to High(Cil) do
          if (Cil[J].X = Bod.Souradnice.X) and (Cil[J].Y = Bod.Souradnice.Y) then
          begin
            Vysledek := Cesta;
            Konec := True;
          end;
      end;
    until Konec;
    if Vysledek <> nil then
    begin
      for I := 1 to Vysledek.Count -1 do
      begin

        s := IntToStr(TBod(Vysledek[I]).Zmena.X) + ', ';
        s := s + IntToStr((TBod(Vysledek[I]).Zmena.Y*(-1)));
                                                   
        mCesta.Lines.Add(s);
      end;
    end;
  end else
    Error('dn mapa nen natena !');
end;

procedure TForm1.cbPolickoChange(Sender: TObject);
begin
  dgMapa.DefaultColWidth := StrToInt(cbPolicko.Items[cbPolicko.ItemIndex]);
  dgMapa.DefaultRowHeight := StrToInt(cbPolicko.Items[cbPolicko.ItemIndex]);
end;

end.
